unit pasPrincipal;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls;

type
  TfrmPrincipal = class(TForm)
    GroupBox1: TGroupBox;
    btnIniciaComunicacao: TButton;
    btnEncerraComunicacao: TButton;
    GroupBox2: TGroupBox;
    rdbVT100ESC: TRadioButton;
    rdbVT100STX: TRadioButton;
    GroupBox3: TGroupBox;
    mmoMensagem: TMemo;
    btnStatus: TButton;
    Timer1: TTimer;
    Label3: TLabel;
    txtMensagem: TEdit;
    btnEscreveDisplay: TButton;
    btnLimpaDisplay: TButton;
    btnLerTeclado: TButton;
    btnLimpar: TButton;
    GroupBox4: TGroupBox;
    txtTexto: TEdit;
    Label4: TLabel;
    rdbSerial1: TRadioButton;
    rdbSerial2: TRadioButton;
    btnEnviar: TButton;
    Label5: TLabel;
    txtIdTerminal: TEdit;
    btnLerLeitor: TButton;
    GroupBox5: TGroupBox;
    Label1: TLabel;
    txtLinha: TEdit;
    Label2: TLabel;
    txtColuna: TEdit;
    btnPosicionaCursor: TButton;
    rdbNormal: TRadioButton;
    rdbPiscante: TRadioButton;
    btnSair: TButton;
    procedure btnIniciaComunicacaoClick(Sender: TObject);
    procedure btnEncerraComunicacaoClick(Sender: TObject);
    procedure btnStatusClick(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure btnEscreveDisplayClick(Sender: TObject);
    procedure btnLimpaDisplayClick(Sender: TObject);
    procedure btnLerTecladoClick(Sender: TObject);
    procedure btnLimparClick(Sender: TObject);
    procedure btnEnviarClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure btnLerLeitorClick(Sender: TObject);
    procedure btnPosicionaCursorClick(Sender: TObject);
    procedure btnSairClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
   procedure VerificaVersao(Sender: TObject);
   procedure TimerCodigoBarras(Sender: TObject);
  end;

var
  frmPrincipal: TfrmPrincipal;
  globalTimeout: Tdatetime;
  cBuffer: string;
  bTeclado: boolean;

implementation

uses DateUtils;

// Funes especficas para o micro-terminal FIT BASIC Bematech

function Bematech_FIT_IniciaComunicacao(): integer; stdcall; external 'BEMASB32.DLL';
function Bematech_FIT_FechaComunicacao(): integer; stdcall; external 'BEMASB32.DLL';
function Bematech_FIT_SelecionaProtocolo( Protocolo: integer ): integer; stdcall; external 'BEMASB32.DLL';
function Bematech_FIT_LimpaDisplay( Terminal: byte ): integer; stdcall; external 'BEMASB32.DLL';
function Bematech_FIT_EscreveDisplay( Terminal: byte; Mensagem: string ): integer; stdcall; external 'BEMASB32.DLL';
function Bematech_FIT_PosicionaCursor( Terminal: byte; Linha: byte; Coluna: byte ): integer; stdcall; external 'BEMASB32.DLL';
function Bematech_FIT_LerBuffer( Terminal: byte ): char; stdcall; external 'BEMASB32.DLL';
function Bematech_FIT_EnviaSerial( Terminal: byte; Dados: byte; Serial: byte ): integer; stdcall; external 'BEMASB32.DLL';
function Bematech_FIT_ApagaLinha( Terminal: byte ): integer; stdcall; external 'BEMASB32.DLL';
function Bematech_FIT_DeslocaCursorCima( Terminal: byte ): integer; stdcall; external 'BEMASB32.DLL';
function Bematech_FIT_DeslocaCursorDireita( Terminal: byte ): integer; stdcall; external 'BEMASB32.DLL';
function Bematech_FIT_VersaoFirmware( Terminal: byte ): integer; stdcall; external 'BEMASB32.DLL';
function Bematech_FIT_ComandoGenerico( Terminal: byte; Comando: byte ): integer; stdcall; external 'BEMASB32.DLL';
function Bematech_FIT_LeituraCodigoBarras( Terminal: byte ): integer; stdcall; external 'BEMASB32.DLL';
function Bematech_FIT_EnviaComando( Comando: string ): integer; stdcall; external 'BEMASB32.DLL';

{$R *.dfm}

procedure TfrmPrincipal.btnIniciaComunicacaoClick(Sender: TObject);
var
   iRetorno: integer;
begin
   if ( txtIdTerminal.Text = '' ) then
      begin
         Application.MessageBox( 'Informe o nmero do terminal !', 'Ateno', MB_ICONINFORMATION + MB_OK );
         txtIdTerminal.SetFocus;
         exit;
      end;

   // Inicia a comunicao com o FIT Bsico
   iRetorno := Bematech_FIT_IniciaComunicacao();

   // Seleciona o protocolo de comunicao
   // 1 para VT100-ESC
   // 0 para VT100-STX/ETX
   // Obs: Depende de como est programado no terminal
   //      Para verificar use o boto "Verificar Dados Terminal"

   if ( rdbVT100ESC.Checked = true ) then
      iRetorno := Bematech_FIT_SelecionaProtocolo( 1 )
   else
      iRetorno := Bematech_FIT_SelecionaProtocolo( 0 );

end;

procedure TfrmPrincipal.btnEncerraComunicacaoClick(Sender: TObject);
var
   iRetorno: integer;
   tmp: char;
begin
   timer1.Enabled := false;
   iRetorno := Bematech_FIT_FechaComunicacao();
   exit;
end;

procedure TfrmPrincipal.btnStatusClick(Sender: TObject);
var
   iRetorno: integer;
   tmp: char;
begin

   globalTimeout := now;
   mmoMensagem.Lines.Clear;

   cBuffer := '';

   Timer1.OnTimer := VerificaVersao;
   Timer1.Tag     := 0;
   Timer1.Interval:= 10;
   Timer1.Enabled := true;
   iRetorno := Bematech_FIT_VersaoFirmware( strtoint( txtIdTerminal.Text ) );
end;

procedure TfrmPrincipal.Timer1Timer(Sender: TObject);
var
  tmp: char;
begin

   if ( bTeclado ) then
      begin
         // Repete at que todos os dados tenham sido transferidos
         repeat
            tmp := Bematech_FIT_LerBuffer( strtoint( txtIdTerminal.Text ) );
            Bematech_FIT_EscreveDisplay( strtoint( txtIdTerminal.Text ), tmp );
            mmoMensagem.Text := mmoMensagem.Text + tmp;
         until (tmp = #0);
      end
   else
      begin
         // Repete at que o leitor envie o ENTER
         repeat
            tmp := Bematech_FIT_LerBuffer( strtoint( txtIdTerminal.Text ) );
            mmoMensagem.Text := mmoMensagem.Text + tmp;
         until (tmp = #13);
      end;

end;
procedure TfrmPrincipal.VerificaVersao(Sender: TObject);
var
   tmp    : char;
begin

   tmp := Bematech_FIT_LerBuffer( strtoint( txtIdTerminal.Text ) );

   if ( ( Timer1.tag = 1 ) and ( tmp <> #03 ) ) then
      cBuffer := cBuffer + tmp;

   if ( tmp = #02 ) then
      Timer1.tag := 1;

   if ( tmp = #13 ) then
      begin
         mmoMensagem.lines.add( copy( cBuffer, 1, length( cBuffer ) - 2 ) );
         cBuffer := '';
      end;

   if ( tmp = #03 ) then
   begin
     Timer1.tag := 0;
     Timer1.enabled := False;
   end;

   if ( SecondsBetween( now, globalTimeout ) > 60 ) then
   begin
     Timer1.tag := 0;
     Timer1.enabled := False;
     Application.MessageBox( 'Erro de time-out na leitura dos bytes !', 'Erro', MB_ICONINFORMATION + MB_OK );
   end;

end;

procedure TfrmPrincipal.TimerCodigoBarras(Sender: TObject);
var
  tmp:char;
begin
   tmp := Bematech_FIT_LerBuffer( strtoint( txtIdTerminal.Text ) );

   if ( ( Timer1.tag = 1 ) and ( tmp <> #03 ) ) then
     cBuffer := cBuffer + tmp;

   if ( tmp = #02 ) then
      Timer1.tag := 1;

   if ( tmp = #03 ) then
      begin
        Timer1.tag := 0;
        Timer1.enabled := False;
        cBuffer := cBuffer + '<';
      end;

   if (tmp = #27) then
      begin
         Timer1.tag := 0;
         Timer1.enabled := False;
         tmp := Bematech_FIT_LerBuffer( strtoint( txtIdTerminal.Text ) ); // recebe 03
         btnLerLeitor.Caption := 'Ativar Leitura Cdigo Barras';
         Application.MessageBox( 'Abortado atravs da tecla ESC !', 'Ateno', MB_ICONINFORMATION + MB_OK );
      end;

   if (tmp = #01) then
      begin
         Timer1.tag := 0;
         Timer1.enabled := False;
         Bematech_FIT_LerBuffer( strtoint( txtIdTerminal.Text ) ); // recebe 03
         btnLerLeitor.Caption := 'Ativar Leitura Cdigo Barras';
         Application.MessageBox( 'Timeout na leitura dos dados !', 'Ateno', MB_ICONERROR + MB_OK );
      end;

   if (SecondsBetween(now, globalTimeout) > 60) then
      begin
         Timer1.tag := 0;
         Timer1.enabled := False;
         btnLerLeitor.Caption := 'Ativar Leitura Cdigo Barras';
         Application.MessageBox( 'Timeout na leitura - Software !', 'Ateno', MB_ICONERROR + MB_OK );
      end;
end;

procedure TfrmPrincipal.btnEscreveDisplayClick(Sender: TObject);
var
   iRetorno: integer;
begin
   iRetorno := Bematech_FIT_EscreveDisplay( strtoint( txtIdTerminal.Text ) , txtMensagem.Text );
end;

procedure TfrmPrincipal.btnLimpaDisplayClick(Sender: TObject);
var
   iRetorno: integer;
begin
   iRetorno := Bematech_FIT_LimpaDisplay( strtoint( txtIdTerminal.Text ) );
end;

procedure TfrmPrincipal.btnLerTecladoClick(Sender: TObject);
begin
   bTeclado := true;
   if not Timer1.Enabled then
      begin
         btnLerTeclado.Caption := 'Desativar Leitura Teclado/CCD';
         Timer1.OnTimer := Timer1Timer;
         Timer1.Enabled := True;
      end
   else
      begin
         btnLerTeclado.Caption := 'Ativar Leitura Teclado/CCD';
         Timer1.Enabled := False
      end;
end;

procedure TfrmPrincipal.btnLimparClick(Sender: TObject);
begin
   mmoMensagem.Clear;
end;

procedure TfrmPrincipal.btnEnviarClick(Sender: TObject);
var
   cmd   : string;
   iConta:integer;
   Serial: Byte;
begin
   cmd := txtTexto.Text + #10 + #13;

   if rdbSerial1.Checked then
      Serial := Ord('S')
   else
      Serial := Ord('R');

   for iConta:= 1 to length(cmd) do
      begin
         if Bematech_FIT_EnviaSerial( strtoint( txtIdTerminal.Text ), ord( cmd[ iConta ] ), Serial ) = 0 then
            begin
               Showmessage('Erro comunicao !!');
               Exit;
            end;
      end;
end;

procedure TfrmPrincipal.FormClose(Sender: TObject;
  var Action: TCloseAction);
var
   iRetorno: integer;
begin
   timer1.Enabled := false;
   iRetorno := Bematech_FIT_FechaComunicacao();
   exit;
end;

procedure TfrmPrincipal.btnLerLeitorClick(Sender: TObject);
begin
   bTeclado := false;
   if not Timer1.Enabled then
      begin
         btnLerLeitor.Caption := 'Desativar Leitura Cdigo Barras/CMC-7';
         Timer1.OnTimer := TimerCodigoBarras;
         Timer1.Interval := 10;
         Timer1.Enabled := True;

         cBuffer := '>';
         globalTimeout := now;

         Bematech_FIT_LeituraCodigoBarras( strtoint( txtIdTerminal.Text ) );

      end
   else
      begin
         btnLerLeitor.Caption := 'Ativar Leitura Cdigo Barras/CMC-7';
         Timer1.Enabled := False
      end;
end;

procedure TfrmPrincipal.btnPosicionaCursorClick(Sender: TObject);
begin

   if ( rdbNormal.Checked = true ) then
      Bematech_FIT_ComandoGenerico( strtoint( txtIdTerminal.Text ), 14 )
   else
      Bematech_FIT_ComandoGenerico( strtoint( txtIdTerminal.Text ), 15 );

   Bematech_FIT_PosicionaCursor( strtoint( txtIdTerminal.Text ), strtoint( txtLinha.text ), strtoint( txtColuna.text ) );
end;

procedure TfrmPrincipal.btnSairClick(Sender: TObject);
begin
   Close;
end;

end.
